// ============================================================================================
// CN[ht@C
// ============================================================================================
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

#include "audioeffectx.h"

//fBCp̏zobt@NX`̃CN[h
#include "CRingBuffer.h"

// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_VENDOR       "test vendor"        //(x_[)
#define MY_VST_VERSION      1                    //VSTo[W
#define MY_VST_PRODUCT_NAME "Sample Delay VST"   //VST̐i
#define MY_VST_NAME         "Delay"              //VST̖O

#define MY_VST_INPUT_NUM   1 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 3 //p[^̐

//VST̃p[^`ĂB
//0̘AԂłȂ΂ȂȂB
#define EFF_PAN      0
#define EFF_PHASE_L  1
#define EFF_PHASE_R  2

//VSTŎgl̒`
#define DELAY_MAX 20.0f // fBC̍őb(~bP)
// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class My596VST : public AudioEffectX
{
protected:
	CRingBuffer RingBufL;
	CRingBuffer RingBufR;

	float fPan;
	float fPhaseL;
	float fPhaseR;

	float CalcPhase(float val) { return getSampleRate() * (DELAY_MAX * val / 1000.0f);};
public:
	My596VST (audioMasterCallback audioMaster);
	~My596VST ();

	//(x_[)Ao[WAiAVST̖O
	//HostAvP[V֒m点郁o[֐
	virtual bool getVendorString (char* text);
	virtual VstInt32 getVendorVersion ();
	virtual bool getProductString (char* text);
	virtual bool getEffectName (char* name);

	// GtFN^[̃p[^Ɋւ郁o[֐
	virtual void  setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void  getParameterName (VstInt32 index, char* text);
	virtual void  getParameterLabel (VstInt32 index, char* label);
	virtual void  getParameterDisplay (VstInt32 index, char* text);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
};

// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new My596VST (audioMaster);
}

// ============================================================================================
// RXgN^AfXgN^(VST̏AILq)
// ============================================================================================
My596VST::My596VST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//VST̃p[^B
	fPan    = 0.5f;
	fPhaseL = 0.0f;
	fPhaseR = 0.0f;

	RingBufL.SetInterval((int)CalcPhase(fPhaseL));
	RingBufR.SetInterval((int)CalcPhase(fPhaseR));
}

My596VST::~My596VST ()
{
	//VST̏IB
	//VSTł͓Ɏs鏈͂ȂB
}

// ============================================================================================
// (x_[)Ao[WAiAVST̖OHostAvP[V֒m点郁o[֐
// ============================================================================================
bool My596VST::getVendorString (char* text)
{
	//(x_[)textɊi[trueԂB
	//kVstMaxVendorStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxVendorStrLen = 64)
	vst_strncpy (text, MY_VST_VENDOR, kVstMaxVendorStrLen);
	return true;
}

VstInt32 My596VST::getVendorVersion ()
{
	//o[W()ԂB
	return MY_VST_VERSION;
}

bool My596VST::getProductString (char* text)
{
	//itextɊi[trueԂB
	//kVstMaxProductStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxProductStrLen = 64)
	vst_strncpy (text, MY_VST_PRODUCT_NAME, kVstMaxProductStrLen);
	return true;
}

bool My596VST::getEffectName (char* name)
{
	//inameɊi[trueԂB
	//kVstMaxEffectNameLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxEffectNameLen = 32)
	vst_strncpy (name, MY_VST_NAME, kVstMaxEffectNameLen);
	return true;
}

// ============================================================================================
// GtFN^[̃p[^[̐ݒA\so[֐
// ============================================================================================
void  My596VST::setParameter (VstInt32 index, float value)
{
	//indexŎw肳ꂽp[^ɒlݒ肷B
	//value0.0f`1.0fŗ^B
	switch (index)
	{
	case EFF_PAN:
		fPan = value;
		break;
	case EFF_PHASE_L:
		fPhaseL = value;
		RingBufL.SetInterval((int)CalcPhase(fPhaseL));
		break;
	case EFF_PHASE_R:
		fPhaseR = value;
		RingBufR.SetInterval((int)CalcPhase(fPhaseR));
		break;
	default:
		break;
	}
}

float My596VST::getParameter (VstInt32 index)
{
	//indexŎw肳ꂽp[^̒l
	//0.0f`1.0f͈̔͂ŕԂ
	float value = 0.0f;
	switch (index)
	{
	case EFF_PAN:
		value = fPan;
		break;
	case EFF_PHASE_L:
		value = fPhaseL;
		break;
	case EFF_PHASE_R:
		value = fPhaseR;
		break;
	default:
		break;
	}
	return value;
}

void  My596VST::getParameterName (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̖OtextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case EFF_PAN:
		vst_strncpy (text, "Pan", kVstMaxParamStrLen);
		break;
	case EFF_PHASE_L:
		vst_strncpy (text, "PhaseL", kVstMaxParamStrLen);
		break;
	case EFF_PHASE_R:
		vst_strncpy (text, "PhaseR", kVstMaxParamStrLen);
		break;
	default:
		break;
	}
}

void  My596VST::getParameterLabel (VstInt32 index, char* label)
{
	//indexŎw肳ꂽp[^̒PʂlabelɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case EFF_PAN:
		vst_strncpy (label, "", kVstMaxParamStrLen);
		break;
	case EFF_PHASE_L:
		vst_strncpy (label, "m sec", kVstMaxParamStrLen);
		break;
	case EFF_PHASE_R:
		vst_strncpy (label, "m sec", kVstMaxParamStrLen);
		break;
	default:
		break;
	}
}

void  My596VST::getParameterDisplay (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̕\etextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case EFF_PAN:
		float2string ((fPan - 0.5f) * 2.0f, text, kVstMaxParamStrLen);
		break;
	case EFF_PHASE_L:
		float2string (fPhaseL * DELAY_MAX, text, kVstMaxParamStrLen);
		break;
	case EFF_PHASE_R:
		float2string (fPhaseR * DELAY_MAX, text, kVstMaxParamStrLen);
		break;
	}
}

// ============================================================================================
// M郁o[֐
// ============================================================================================
void My596VST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* inL  =  inputs[0]; // (m)
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	while (sampleFrames > 0)
	{
		//ŉsB

		RingBufL.SetValue( (*inL));
		RingBufR.SetValue( (*inL));
		//o̓obt@֏ށB
		(*outL) = 2.0f * (1.0f - fPan) * RingBufL.GetValue();
		(*outR) = 2.0f * fPan * RingBufR.GetValue();

		RingBufR.ForwardReadPosition();
		RingBufL.ForwardReadPosition();

		RingBufR.ForwardWritePosition();
		RingBufL.ForwardWritePosition();

		inL++;
		outL++;
		outR++;
		sampleFrames--;
	}

}

